#! perl

# Check command line arguments (none required)
if ( $ARGV[0] ) {
	Syntax();
}

# Create temporary DEBUG script
$dbg = "D FFFF:0005 L 8\nQ\n";
open( DBGSCR, "> biosdate.dbg" ) || die( "Cannot open temporary DEBUG script: $!" );
print DBGSCR $dbg;
close DBGSCR;

# Run DEBUG script and filter output;
# improved DEBUG output filtering by Uri "Talentix"
`debug.exe < biosdate.dbg` =~ /(\d\d\/\d\d\/\d\d)/;
print "\nBIOS date: ".$1."\n";

# Delete temporary DEBUG script
`DEL biosdate.dbg >NUL 2>&1`;


sub Syntax {
	print "\nBIOSDate.pl,  Version 1.10 for DOS, Windows & OS/2\n",
	      "Display BIOS date of local computer\n\n",
	      "Usage:  BIOSDATE.PL\n\nThis script uses ",
	      "DEBUG.EXE to read the information from BIOS.\n",
	      "Tested in Windows 2000 only.\n\nWritten by ",
	      "Rob van der Woude\nhttp://www.robvanderwoude.com\n\n",
	      "Improved DEBUG output filtering by Uri \"Talentix\"\n\n",
	      "Original idea by ComputerHope\n",
	      "http://www.computerhope.com/rdebug.htm\n\n\n";
}
